﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CG2.Mathematics;
using CG2.Modeling;
using System.Drawing;

namespace CG2.Rendering
{
    public class KdTreeNode : KdTreeAccelerator
    {
        #region Properties

        //ToDo: You should use these default properties and add your own. As always, you can change the structure and implement your own.
        //Info: Min and max box for the models
        public Vector4 Min = new Vector4(Double.MaxValue, Double.MaxValue, 0, 0);
        public Vector4 Max = new Vector4(-Double.MaxValue, -Double.MaxValue, 0, 0);

        //Info: Properties used to define the best axis due to SAH
        public Vector4 Origin;
        public Vector4 Normal;

        //Info: Properties for models above the best axis and below the best axis
        public KdTreeNode UpChild;
        public KdTreeNode DownChild;

        //Info: Models of the entire scene
        public List<Model> Models;
        
        #endregion

        public void Init(List<Sphere> prims, Graphics g)
        {
            //ToDo: You can start at the root node (entire scene of models) and build the structure
            //1. Get the best axis. Prejdem vsetky osi a ta ktora pohlcuje najviac priestoru vratim.
            //2. Construct the edges array
            //3. Go through all edges along that axis and control the cost along that axis. Cost computation is from SAH 
            //4. If there is not a good way to split this volume go to another axis
            //5. Divide the objects into two separate nodes acording to the plane and go to the next level of the tree structure
            //6. Building ends if the node has 2 models or less.

            //Hints:
            //Trace your program and test if it builds the structure correctly
            //Implementation should be for spheres and 2D, but you should also plan your implementation for other primitives and 3D enhancement
        }

        public void Collide(Ray ray, Double t0, Double t1, Graphics g)
        {
            //ToDo: You can start the traversal at the root node (entire scene of models) 
            //1. The direction of traversal is t0, t and t1 dependent
            //2. Test the intersection if the node has some models.
            //3. If node has some models in it, check the ray against the min max box of those models, in other case it is not the node and you need to go deeper
            //4. If it intersects go through all the models in this node
            //5. Traversal ends when there is some intersection - return model and parameter
            //6. Traversal ends if there is no intersection at all - return only
            
            //Hints:
            //Algorithm should only check the models in nodes, and that is also only when there is intersection with the min max box
            //Best case - we wil go through the tree to its node and check one or two models and intersection with them
            //This is why we need to start with the child who is closer to the t0 - it would be pointless to start with the farest child (we want only intersection with the first and closest model)
        }
    }
}
